S3 にスライドを保存することにした

# 伝えること

* S3 で静的ホスティングをしてみた
* Haskell で AWS API を叩いた

# 対象

* S3を知らない人
* Haskellプログラミングに興味がある人

# 内容

* マシンに空き容量がない!
* ちょっとづつデータを外に出さねば
* .key ファイルが意外にでかいし、とっておきたい
* 画像をつくったりすると他にもいろいろファイルが…

* http://keynotes.eiel.info/

# S3つかいました

S3とは？
Amazon Web Service が提供するストレージサービス
1GB あたり 0.03$
バケットという置場には容量制限がない(フォルダみたいなやつ)

以前 GitHub におきまくってたらスパム判定にひっかかりました

# index.html の生成

* S3 には静的ファイルであれはホスティング機能がある

* 置いてるファイルの一覧を取得して生成
* そのうちアップロードをフックして自動更新したい

# keynotes.eiel.info の index.html を支える技術

https://github.com/eiel/keynotes-eiel

## 言語

* Haskell
最初Rubyでかいてたけど…

* aws

Haskell で AWSのAPIをたたく <初挑戦>

* shakespeare

型安全らしいテンプレートエンジン <初挑戦>


## aws

cfg <- Aws.baseConfiguration
let s3cfg = Aws.defServiceConfig :: S3.S3Configuration Aws.NormalQuery

withManager $ \mgr -> do
  S3.GetBucketResponse { S3.gbrContents = objectInfo } <-
    Aws.pureAws cfg s3cfg mgr $
      S3.getBucket bucketName


Aws.pureAws cf s3cfg mgr apiっぽい関数

よくわからないところはたくさんあるけど、api のところだけ変えればいろいろできそう

## shakespeare

Yesod で使われているHTMLやCSSやJavaScriptのためのテンプレートエンジン


toHtml infos = renderHtml $ [shamlet|
$doctype 5
<html>
  <head>
    <title>keynotes.eiel.info
  <body>
    <h1>スライドの保存場所
    ここはスライドの保存庫
    <ul>
    $forall info <- infos
      ^{list info}
|]

## つまづいた点

ファイルを送りつけるときに MimeType を指定しなかったら HTML が表示されずにダウンロードされてしまった

* String を ByteString に変換したら文字化けした。

ファイルを送信するのに ByteString にする必要があった。
一旦 Text に変換したらうまくいった。

T.encodeUtf8 . T.pack $ html

renderHtml がそもそも ByteString にできたのでそっちにした
しかし Lazy.ByteString で型があわなかった

B.concat . B.toChunks $ html

* レコードが使いこなせてない

let object = S3.putObject bucketName "index.html" body
Aws.pureAws cfg s3cfg mgr $ object { S3.poContentType = Just "text/html" }

* shamlet と hamlet の違いがよくわかってない

hamlet のほうはルーティング情報を渡してるっぽいけど

## 今後の展望

* スタイルシートつけよう
* 画像欲しいよね
* 汎化して他の人も使えるようにしよう
* ログの収集とかしないと
* バケットの構築も自動化したいね

## まとめ

* APIで操作できる AWS 楽しい
* Haskell でもプログラミングできますね
